%define ALD_Ver		1.2.1

%define OrgName busybox
Name:         uC-%{OrgName}

License:      GPL
Summary:      BusyBox (build static-uClibc)
Group:        System Environment/Shells
Version:      1.21.1
Release:      0

Source: %{OrgName}-%{version}.tar.xz
Source1: CROSS-uC.sh
Source2: %{OrgName}-%{version}.config_su
Source3: %{OrgName}-%{version}.config_boot
Source4: %{OrgName}-%{version}.config
Source5: busybox-udhcpc-default.script

%define DestDir		/Embedded/uC-%{uC_Version}
%define uC_Version 0.9.33.2

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/usr/uC/%{uC_Version}/static/bin

%define __os_install_post %{nil}

%define _srcrpmdir %{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir %{nil}
%define csysbindir	/usr/uC/%{uC_Version}/static/bin
%define CrossDestDir %{nil}
%define _srcrpmdir %{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_arch}-uclibc

%endif # !_CROSS || !TARGETBUILD_CROSS

%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  This package can be very
useful for recovering from certain types of system failures,
particularly those involving broken shared libraries.
# --------------------------------------
%package env
Summary:      BusyBox env
Group:        System Environment/Shells
Provides:     env
%description env
BusyBox env
# --------------------------------------
%package doc
Summary:      doc for %{OrgName}
Group:        Documentation
%description doc
doc for %{OrgName}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}

cp %SOURCE2 .config
sed -i s:"CONFIG_CROSS_COMPILER_PREFIX=\"\"":"CONFIG_CROSS_COMPILER_PREFIX=\"%{_arch}-uclibc-\"": .config
%ifarch x86_64
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-fno-asynchronous-unwind-tables\"": .config
%endif
%ifarch %{arm}
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-march=%{ARM_ARCH} %{ARM_FPU}\"": .config
%endif
sed -i s:"\"busybox\", 7":"\"busybox_su\", 10": libbb/appletlib.c
sed -i s:"\"busybox\"":"\"busybox_su\"": libbb/appletlib.c

# ------------------- Build ------------------------------------------
%Build
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
UCLIBC_GCC_INC_SKIP=%{csysdir}/usr/include
export PATH GCC_NoHostPath UCLIBC_GCC_INC_SKIP

# ------- built busybox_su
make V=1 &>FMake_log0.txt
mv busybox busybox_su
mv docs/busybox.net/BusyBox.html docs/busybox.net/BusyBox_su.html

# ------- built busybox_boot
cp %SOURCE3 .config
sed -i s:"CONFIG_CROSS_COMPILER_PREFIX=\"\"":"CONFIG_CROSS_COMPILER_PREFIX=\"%{_arch}-uclibc-\"": .config
%ifarch x86_64
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-fno-asynchronous-unwind-tables\"": .config
%endif
%ifarch %{arm}
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access\"": .config
%endif
sed -i s:"\"busybox_su\", 10":"\"busybox_boot\", 12": libbb/appletlib.c
sed -i s:"\"busybox_su\"":"\"busybox_boot\"": libbb/appletlib.c

make V=1 &>FMake_log1.txt
mv busybox busybox_boot
mv docs/busybox.net/BusyBox.html docs/busybox.net/BusyBox_boot.html

# ------- built busybox
cp %SOURCE4 .config
sed -i s:"CONFIG_CROSS_COMPILER_PREFIX=\"\"":"CONFIG_CROSS_COMPILER_PREFIX=\"%{_arch}-uclibc-\"": .config
%ifarch x86_64
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-fno-asynchronous-unwind-tables\"": .config
%endif
%ifarch %{arm}
sed -i s:"CONFIG_EXTRA_CFLAGS=\"\"":"CONFIG_EXTRA_CFLAGS=\"-march=%{ARM_ARCH} %{ARM_FPU}\"": .config
%endif
sed -i s:"\"busybox_boot\", 12":"\"busybox\", 7": libbb/appletlib.c
sed -i s:"\"busybox_boot\"":"\"busybox\"": libbb/appletlib.c

make V=1 &>FMake_log2.txt

# ------------------- Install ----------------------------------------
%Install
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}/html

cp busybox busybox_su busybox_boot $RPM_BUILD_ROOT/bin/
#cp busybox $RPM_BUILD_ROOT/bin/
chmod 04755 $RPM_BUILD_ROOT/bin/busybox_su

cp docs/busybox.net/* $RPM_BUILD_ROOT%{docdir}/html
cp AUTHORS LICENSE README $RPM_BUILD_ROOT%{docdir}/

mkdir -p $RPM_BUILD_ROOT/etc
cp examples/udhcp/udhcpd.conf $RPM_BUILD_ROOT/etc/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/udhcpc 
cp %SOURCE5 $RPM_BUILD_ROOT%{_datadir}/udhcpc/default.script

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

mkdir -p $RPM_BUILD_ROOT%{_bindir}
pushd $RPM_BUILD_ROOT%{_bindir}
ln -s /bin/busybox env
popd

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
  mv %{name}-env-$SE $DD/%{name}-env-$DE
popd

%if %{BUILD_TAR}
# --------------- build *.tgz ------------------------
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r bin etc usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%Files
/bin
/etc
%{_datadir}/udhcpc
%{docdir}/AUTHORS
%{docdir}/LICENSE
%{docdir}/README

%Files env
%{_bindir}/env

%Files doc
%{docdir}/html

